/*
 * Stack.java
 * Interface for Stacks, 
 * throws Overflow, Underflow RuntimeExceptions, unchecked
 */

package datastructures;

/**
 *
 * @author  hs
 */

interface Stack { 
    
    // model:  [Object]  
    // inv:    length < N = 20


    int MAX = 100;     
    
    void  init();    
    // pre:   True   
    // post:  returns [] 

    void init (int capacity); 
    // pre:   true
    // post:  returns stack of user defined size
 
    void push(Object x) throws Overflow;
    // pre:   length s < max
    //          -- else Overflow
    // post:  s == [x] ++ S                  
    //          if self == S 
  
    void pop() throws Underflow;
    // pre:   not([])
    //          -- else Underflow
  
    //post:   effect:  if self == x:restStack then restStack
    //returns - 

    Object top() throws Underflow;
    // pre:   not([])
    //          -- else Underflow
    //post:   no effect on stack
    //returns x,  if  self == x:s
  
  
    int size();
    // pre:   true
    // post:  result = length s 
}
