/*
 * StackArray.java
 *
 */

package datastructures;

/**
 *
 * @author  hs
 */
public class StackArray implements Stack {
   
    final private int   MAX = 100; 
    private Object[] s; 
    private int right = 0; 

    /** Creates a new instance of StackArray */
    protected StackArray() {
        s = new Object[MAX];  // Standard stack size
    }
    
    protected StackArray (int capacity) {
        s = new Object[capacity];  // user defined stack size
    }
     
    public void init() {
       new StackArray();
    }
    
    public void init(int cap) {
       new StackArray(cap);
    }
    
    public void pop() throws Underflow {
        if (right == 0) throw new datastructures.Underflow();
        else right--; 
    }
    
    public void push(Object obj) throws datastructures.Overflow {
        if (right == s.length) throw (new datastructures.Overflow());
        else { 
            s[right] = obj; 
            right++;
        }
    }
    
    public int size() {
        return right;
    }
    
    public Object top() throws datastructures.Underflow {
       if (right == 0) throw new datastructures.Underflow();
       else return s[right-1];  
   }  
    
}
